Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 24 by niro, Wed Jan 5 05:08:01 2005 UTC revision 2157 by niro, Wed Aug 14 07:38:37 2013 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # version: 0.3.6-r8  
8    
9  #01.10.2004  
10  # added ccache support  # set default user mage.rc
11  # added distcc support  : ${MAGERC="/etc/mage.rc"}
12    
13    # export default C locale
14    export LC_ALL=C
15    
16    source /etc/mage.rc.global
17    source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    source ${MLIBDIR}/smage2.functions.sh
20    
21  ## setup ##  ## setup ##
 SMAGEVERSION=0.3.6-r8  
 PKGSUFFIX="mpk"  
22  SMAGENAME="$1"  SMAGENAME="$1"
23  SMAGESUFFIX="smage2"  SMAGEVERSION="$(< ${MLIBDIR}/version)"
24  #SOURCEDIR="/bootstrap/sources"  
25  #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
26  #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  if [[ -n ${MROOT} ]]
27  MLIBDIR=/usr/lib/mage  then
28     export PKGDIR=${MROOT}/${PKGDIR}
29  source /etc/mage.rc   export BUILDDIR=${MROOT}/${BUILDDIR}
30     export BINDIR=${MROOT}/${BINDIR}
31  showversion() {  fi
32   echo -en "Magellan Source Install v${SMAGEVERSION} "  
33   echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  # print out our version
34  }  showversion
35    echo
36  die() {  
37   xtitleclean  if [[ -z ${SMAGENAME} ]]
38   echo "SMAGE failed: $@"  then
39     echo "No .smage2 file given. Exiting."
40     echo
41   exit 1   exit 1
42  }  fi
43    
44  xtitle() {  # load supported mage features
45   if [ ${TERM} == "xterm" ]  load_mage_features
46    
47    # updating smage2-scripts
48    if [[ $1 = update ]]
49    then
50     if [ ! -d ${SOURCEDIR} ]
51   then   then
52   echo -ne "\033]0;[sMage: $@]\007"   install -d ${SOURCEDIR}
53   fi   fi
54   return 0   syncsmage2
55  }   exit 0
56    fi
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
   
 build_mage_script() {  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
57    
58  minstall() {  # creates md5sums for smages to given dir
59   if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  if [[ $1 = calcmd5 ]]
60   make prefix=${BINDIR}/usr \  then
61   datadir=${BINDIR}/usr/share \   if [ $# -ge 2 ]
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
62   then   then
63   DEST=${BUILDDIR}   SMAGENAME="$2"
64   else   MD5DIR="$3"
65   DEST=$2   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
66    
67   export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"   smagesource ${SMAGENAME} || die "download source failed"
68    
69     # overridable sourcedir; must be declared after source of the smage2
70     CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
71    
72   #ccache + distcc together   [ -z "${SRC_URI}" ] && die "Nothing declared to calculate."
73   if [ "${SMAGE_USE_CCACHE}" == "true" ]  
74   then   # end of array
75   if [ -x /usr/bin/ccache ]   EOA=${#SRC_URI[*]}
76    
77     [ ! -d ${MD5DIR} ] && install -d ${MD5DIR}
78    
79     # clear md5sum file
80     MY_MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
81     echo -n > ${MY_MD5_FILE}
82    
83     for ((i=0; i < EOA; i++))
84     do
85     # url to file
86     my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"
87    
88     # subdir in sources dir; the my_SRCI_URI file goes to there
89     my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"
90    
91     # if my_src_uri_dest is not equal my_src_uri; than an other dir is used
92     if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]
93   then   then
94   echo "Preparing DistCC to work together with CCache ..."   MY_SRC_FILE="${my_SRC_URI_DEST}/$(basename ${SRC_URI[${i}]})"
95   #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"   else
96  # export CC="ccache distcc"   MY_SRC_FILE="$(basename ${SRC_URI[${i}]})"
 # export CXX="ccache distcc"  
97   fi   fi
  fi  
   
  #creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
98    
99  setup_ccache_environment(){   if [ -e "${CALC_SOURCEDIR}/${MY_SRC_FILE}" ]
100   if [ -x /usr/bin/ccache ]   then
101   then   echo "calculating $(basename ${MY_SRC_FILE}) ..."
102   echo "Using CCache for compilation ..."   ( cd ${CALC_SOURCEDIR}; md5sum "${MY_SRC_FILE}" ) >> ${MY_MD5_FILE}
103   export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   else
104   #unset CC CXX   echo "WARNING: File '$(basename ${MY_SRC_FILE}) not found in ${CALC_SOURCEDIR}."
105     fi
106    
107     # unset them to be shure
108     unset my_SRC_URI
109     unset my_SRC_URI_DEST
110     unset my_SRC_URI_MIRROR
111     unset my_SOURCEDIR
112     done
113    
114     echo
115     echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
116     echo
117     else
118     echo "Usage: Calculating MD5 Sums:"
119     echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
120     echo
121     echo
122     echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
123     echo
124     exit 1
125   fi   fi
 }  
126    
127  if [ -z "$1" ]   exit 0
 then  
  showversion  
  echo  
  echo "No .smage2 file given. Exiting."  
  echo  
  exit 1  
128  fi  fi
129    
130  #updating smage2-scripts  # download sources
131  if [ "$1" == "update" ]  if [ "$1" == "download" -a -n "$2" ]
132  then  then
  showversion  
133   if [ ! -d ${SMAGESCRIPTSDIR} ]   if [ ! -d ${SMAGESCRIPTSDIR} ]
134   then   then
135   install -d ${SMAGESCRIPTSDIR}   install -d ${SMAGESCRIPTSDIR}
136   fi   fi
  syncsmage2  
  exit 0  
 fi  
137    
138     # get smage
139     SMAGENAME="$2"
140     MD5DIR="$(dirname ${SMAGENAME})/md5"
141     smagesource ${SMAGENAME} || die "download source failed"
142    
143  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]   download_sources
144  then   exit 0
  die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  
145  fi  fi
146    
147  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]  # regen-mage-tree
148    if [ "$1" == "only-regen-tree" -a -n "$2" ]
149  then  then
150   die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."   # set correct SMAGENAME
151  fi   SMAGENAME="$2"
152     MD5DIR="$(dirname ${SMAGENAME})/md5"
153     smagesource ${SMAGENAME} || die "regen: smage2 not found"
154    
155  if [ -z "${SOURCEDIR}" ]   regen_mage_tree
 then  
  die "\$SOURCEDIR not found. Please setup your mage.rc correctly."  
 fi  
156    
157  if [ -z "${SMAGESCRIPTSDIR}" ]   # build several targets
158  then   if [[ -n ${MAGE_TARGETS} ]]
159   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   then
160  fi   for target in ${MAGE_TARGETS}
161     do
162     # build md5sum for existing packages
163     generate_package_md5sum \
164     --pcat "${PCAT}" \
165     --pname "${PNAME}" \
166     --pver "${PVER}" \
167     --pbuild "${PBUILD}" \
168     --parch "${ARCH}" \
169     --target "${target}"
170     done
171    
172  if [ -z "${SMAGE2RSYNC}" ]   # build several subpackages
173  then   elif [[ -n ${SPLIT_PACKAGES} ]]
174   echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."   then
175   exit 1   split_save_variables
176  fi   for subpackage in ${SPLIT_PACKAGES}
177     do
178     # get the right variables for the split
179     export PNAME="${subpackage}"
180     split_info_${subpackage}
181     # fix PCATEGORIE -> PCAT
182     if [[ ! -z ${PCATEGORIE} ]]
183     then
184     PCAT="${PCATEGORIE}"
185     unset PCATEGORIE
186     fi
187     # build md5sum for existing packages
188     generate_package_md5sum \
189     --pcat "${PCAT}" \
190     --pname "${PNAME}" \
191     --pver "${PVER}" \
192     --pbuild "${PBUILD}" \
193     --parch "${ARCH}"
194     # restore smage environment
195     split_restore_variables
196     done
197     # unset all saved smage variables
198     split_unset_variables
199    
200  if [ -z "${BINDIR}" ]   else
201  then   # build md5sum for existing packages
202   die "no BINDIR variable found in /etc/mage.rc"   generate_package_md5sum \
203     --pcat "${PCAT}" \
204     --pname "${PNAME}" \
205     --pver "${PVER}" \
206     --pbuild "${PBUILD}" \
207     --parch "${ARCH}"
208     fi
209    
210     exit 0
211  fi  fi
212    
213  if [ -z "${CHOST}" ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
214  then  then
215   die "no CHOST variable found in /etc/mage.rc"   # set correct SMAGENAME
216     SMAGENAME="$2"
217     MD5DIR="$(dirname ${SMAGENAME})/md5"
218    
219     echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
220    
221     smagesource ${SMAGENAME} || die "regen: smage2 not found"
222    
223     if [[ -d ${SOURCEDIR}/${PNAME} ]]
224     then
225     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
226     rm -rf ${SOURCEDIR}/${PKGNAME}
227     fi
228    
229     download_sources
230     source_pkg_build ${SMAGENAME}
231     exit 0
232  fi  fi
233    
234  if [ -z "${CFLAGS}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
235  then  then
236   die "no CFLAGS variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
237     msetfeature "srcpkgtarball"
238    
239     # abort if given file is not a source pkg
240     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
241    
242     # set correct SMAGENAME; use the one that the src_pkg provide
243     # /path/to/SOURCEDIR/PNAME/SMAGENAME
244     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
245    
246     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
247    
248     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
249    
250     # unpack srctarball
251     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
252    
253     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
254    
255     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
256  fi  fi
257    
258  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
259  then  then
260   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
261     SMAGENAME="$2"
262  fi  fi
263    
264    [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
265    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
266     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
267    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
268    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
269    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
270    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
271    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
272    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
273    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
274    
275  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
276  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
277    MD5DIR="$(dirname ${SMAGENAME})/md5"
278    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
279    
280  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
281  #fixes some issues with these functions  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
282    
283    # auto regen mage tree if requested
284    regen_mage_tree
285    
286    if mqueryfeature "srcpkgbuild"
287    then
288     if [[ -d ${SOURCEDIR}/${PNAME} ]]
289     then
290     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
291     rm -rf ${SOURCEDIR}/${PNAME}
292     fi
293    fi
294    
295    # download sources
296    mqueryfeature "srcpkgtarball" || download_sources
297    
298    # fixes some issues with these functions
299  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
300  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
301    export -f src_check || die "src_check export failed"
302  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
303    
304  #fixes some compile issues  # fixes some compile issues
305  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
306  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
307  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
308    then
309     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
310    else
311     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
312    fi
313    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
314  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
315  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
316    
317    # setup distcc
318    # setup for distcc goes *before* ccache, so ccache comes before distcc in path
319    mqueryfeature "distcc" && setup_distcc_environment
320    
321  #setup distcc  # setup ccache
322  #distcc mus be setup *before* ccache, as ccache need to be before distcc in path  mqueryfeature "ccache" && setup_ccache_environment
 if [ "${SMAGE_USE_DISTCC}" == "true" ]  
 then  
  setup_distcc_environment  
 fi  
323    
324  #setup ccache  if mqueryfeature "resume"
 if [ "${SMAGE_USE_CCACHE}" == "true" ]  
325  then  then
326   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
327    
328     # setup build logging
329     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
330     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
331     then
332     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
333     fi
334     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
335    
336  # small sleep to show our settings  else
337  sleep 1   # clean up builddir if a previously one exist
338     if [ -d ${BUILDDIR} ]
339     then
340     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
341     fi
342     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
343    
344  #debug   # clean up srcdir if a previously unpacked one exist
345  #echo "CC=${CC}"   if [ -d ${SRCDIR} ]
346  #echo "CXX=${CXX}"   then
347  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${SRCDIR}
348  #echo "PATH: ${PATH}"   fi
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
349    
350  #cleans up build if a previously one exists   # clean up bindir if a previous build exist or create a new one
351  if [ -d ${BUILDDIR} ]   if [ -d ${BINDIR} ]
352  then   then
353   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BINDIR}
354     fi
355     install -d ${BINDIR} || die "couldn't create \$BINDIR."
356    
357     # clean up package temp dir if a previous build exist
358     if [ -d ${BUILDDIR}/${PKGNAME} ]
359     then
360     rm -rf ${BUILDDIR}/${PKGNAME}
361     fi
362    
363     # clean up stamps dir
364     if [ -d ${BUILDDIR}/.stamps ]
365     then
366     rm -rf ${BUILDDIR}/.stamps
367     fi
368    
369     # setup build logging
370     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
371     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
372    fi
373    
374    if [[ ${PKGTYPE} = virtual ]]
375    then
376     echo "virtual package detected; nothing will be build ..."
377     # automatically set !pkgbuild here too
378     msetfeature "!pkgbuild"
379    else
380     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
381     die_pipestatus 0 "src_prepare failed"
382     resume_stamp src_prepare
383     step_by_step src_prepare
384    
385     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
386     die_pipestatus 0 "src_compile failed"
387     resume_stamp src_compile
388     step_by_step src_compile
389    
390     # only run checks if requested
391     if mqueryfeature "!check"
392     then
393     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
394     else
395     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
396     die_pipestatus 0 "src_check failed"
397     resume_stamp src_check
398     fi
399     step_by_step src_check
400    
401     # build several subpackages
402     if [[ -n ${SPLIT_PACKAGES} ]]
403     then
404     # save bindir & pname
405     split_save_variables
406     export SAVED_BINDIR="${BINDIR}"
407     for subpackage in ${SPLIT_PACKAGES}
408     do
409     split_info_${subpackage}
410     if [[ ${PKGTYPE} = virtual ]]
411     then
412     echo
413     echo -en "${COLBLUE}*** ${COLDEFAULT}"
414     echo -en "Virtual package detected"
415     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
416     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
417    
418     echo "virtual package detected; nothing will be build ..."
419     # automatically set !pkgbuild here too
420     msetfeature "!pkgbuild"
421     else
422     if typeset -f src_install_${subpackage} > /dev/null
423     then
424     # export subpackage bindir
425     export BINDIR="${SAVED_BINDIR}_${subpackage}"
426     # export PNAME, several internal function and include
427     # rely on this variable
428     export PNAME="${subpackage}"
429    
430     echo
431     echo -en "${COLBLUE}*** ${COLDEFAULT}"
432     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
433     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
434     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
435    
436     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
437     die_pipestatus 0 "src_install_${subpackage} failed"
438     resume_stamp src_install_${subpackage}
439     step_by_step src_install_${subpackage}
440     fi
441     fi
442     # restore smage environment
443     split_restore_variables
444     done
445     # unset all saved smage variables
446     split_unset_variables
447     else
448     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
449     die_pipestatus 0 "src_install failed"
450     resume_stamp src_install
451     step_by_step src_install
452     fi
453  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
454    
455  #cleans up srcdir if a previously unpacked one exists  # echo for sake of good-looking
456  if [ -d ${SRCDIR} ]  echo
457    
458    if mqueryfeature "!compressdoc"
459  then  then
460   rm -rf ${SRCDIR}   echo -e "!compressdoc detected; documentation will not be compressed ..."
461    elif mqueryfeature "!pkgbuild"
462    then
463     echo "!pkgbuild detected; skipping documentation compression..."
464    else
465     # compressing doc, info & man files
466     if [[ -n ${SPLIT_PACKAGES} ]]
467     then
468     # save smage environment
469     split_save_variables
470     for subpackage in ${SPLIT_PACKAGES}
471     do
472     # honor split_info
473     split_info_${subpackage}
474     if [[ ${PKGTYPE} = virtual ]]
475     then
476     # automatically set !pkgbuild here too
477     msetfeature "!pkgbuild"
478     fi
479    
480     if mqueryfeature "!compressdoc"
481     then
482     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
483     elif mqueryfeature "!pkgbuild"
484     then
485     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
486     else
487     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
488     resume_stamp post-mcompressdoc_${subpackage}
489     fi
490     # restore smage environment
491     split_restore_variables
492     done
493     # unset saved variables
494     split_unset_variables
495     else
496     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
497     resume_stamp post-mcompressdoc
498     fi
499  fi  fi
500    
501  #cleans up bindir if a previous build exists or creates a new one  if mqueryfeature "!libtool"
 if [ -d ${BINDIR} ]  
502  then  then
503   rm -rf ${BINDIR}   if mqueryfeature "!pkgbuild"
504     then
505     echo "!pkgbuild detected; skipping libtool archive stripping ..."
506     else
507     if [[ -n ${SPLIT_PACKAGES} ]]
508     then
509     # save smage environment
510     split_save_variables
511     for subpackage in ${SPLIT_PACKAGES}
512     do
513     # honor split_info
514     split_info_${subpackage}
515     if [[ ${PKGTYPE} = virtual ]]
516     then
517     # automatically set !pkgbuild here too
518     msetfeature "!pkgbuild"
519     fi
520    
521     if mqueryfeature "!libtool"
522     then
523     if mqueryfeature "!pkgbuild"
524     then
525     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
526     else
527     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
528     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
529     resume_stamp post-mstriplibtoolarchive_${subpackage}
530     fi
531     fi
532    
533     # restore smage environment
534     split_restore_variables
535     done
536     # unset saved variables
537     split_unset_variables
538     else
539     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
540     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
541     resume_stamp post-mstriplibtoolarchive
542     fi
543     fi
544  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
545    
546  #cleans up package temp dir if a previous build exists  if mqueryfeature "purge"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
547  then  then
548   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
549     then
550     echo "!pkgbuild detected; skipping file purgation ..."
551     else
552     if [[ -n ${SPLIT_PACKAGES} ]]
553     then
554     # save smage environment
555     split_save_variables
556     for subpackage in ${SPLIT_PACKAGES}
557     do
558     # honor split_info
559     split_info_${subpackage}
560     if [[ ${PKGTYPE} = virtual ]]
561     then
562     # automatically set !pkgbuild here too
563     msetfeature "!pkgbuild"
564     fi
565    
566     if mqueryfeature "purge"
567     then
568     if mqueryfeature "!pkgbuild"
569     then
570     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
571     else
572     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
573     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
574     resume_stamp post-mpurgetargets_${subpackage}
575     fi
576     fi
577    
578     # restore smage environment
579     split_restore_variables
580     done
581     # unset saved variables
582     split_unset_variables
583     else
584     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
585     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
586     resume_stamp post-mpurgetargets
587     fi
588     fi
589  fi  fi
590    
591  #cleans up timestamp if one exists  # stripping all bins and libs
592  if [ -f /var/tmp/timestamp ]  if mqueryfeature "!strip"
593  then  then
594   mage rmstamp   echo -e "!strip detected; package will not be stripped ..."
595  fi  elif mqueryfeature "!pkgbuild"
596    then
597     echo "!pkgbuild detected; skipping stripping of the package ..."
598    else
599     if [[ -n ${SPLIT_PACKAGES} ]]
600     then
601     # save smage environment
602     split_save_variables
603     for subpackage in ${SPLIT_PACKAGES}
604     do
605     # honor split_info
606     split_info_${subpackage}
607     if [[ ${PKGTYPE} = virtual ]]
608     then
609     # automatically set !pkgbuild here too
610     msetfeature "!pkgbuild"
611     fi
612    
613  src_prepare || die "src_prepare failed"   if mqueryfeature "!strip"
614  src_compile || die "src_compile failed"   then
615  src_install || die "src_install failed"   echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
616     elif mqueryfeature "!pkgbuild"
617     then
618     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
619     else
620     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
621     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
622     resume_stamp post-mstripbins_${subpackage}
623     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
624     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
625     resume_stamp post-mstriplibs_${subpackage}
626     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
627     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
628     resume_stamp post-mstripstatic_${subpackage}
629     fi
630    
631     # restore smage environment
632     split_restore_variables
633     done
634     # unset saved variables
635     split_unset_variables
636     else
637     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
638     run_resume post-mstripbins || mstripbins ${BINDIR}
639     resume_stamp post-mstripbins
640     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
641     run_resume post-mstriplibs || mstriplibs ${BINDIR}
642     resume_stamp post-mstriplibs
643     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
644     run_resume post-mstripstatic || mstripstatic ${BINDIR}
645     resume_stamp post-mstripstatic
646     fi
647    fi
648    
649  #compressing doc, info & man files  if mqueryfeature "qalint"
 echo -e "Compressing man-pages ..."  
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
650  then  then
651   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   if mqueryfeature "!pkgbuild"
652     then
653     echo "!pkgbuild detected; skipping QA lint checks ..."
654     else
655     if [[ -n ${SPLIT_PACKAGES} ]]
656     then
657     # save smage environment
658     split_save_variables
659     for subpackage in ${SPLIT_PACKAGES}
660     do
661     # honor split_info
662     split_info_${subpackage}
663     if [[ ${PKGTYPE} = virtual ]]
664     then
665     # automatically set !pkgbuild here too
666     msetfeature "!pkgbuild"
667     fi
668    
669     if mqueryfeature "qalint"
670     then
671     if mqueryfeature "!pkgbuild"
672     then
673     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
674     else
675     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
676     mqalint ${BINDIR}_${subpackage}
677     fi
678     fi
679    
680     # restore smage environment
681     split_restore_variables
682     done
683     # unset saved variables
684     split_unset_variables
685     else
686     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
687     mqalint ${BINDIR}
688     fi
689     fi
690  fi  fi
691    
692  echo -e "Compressing info-pages ..."  if mqueryfeature "!pkgbuild"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
693  then  then
694   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   echo -e "!pkgbuild detected; Package will not be build ..."
695    else
696     # build several targets
697     if [[ -n ${MAGE_TARGETS} ]]
698     then
699     for target in ${MAGE_TARGETS}
700     do
701     # check if a special target_pkgbuild exists
702     if typeset -f ${target}_pkgbuild > /dev/null
703     then
704     # run it
705     run_resume post-${target}_pkgbuild || ${target}_pkgbuild
706     resume_stamp post-${target}_pkgbuild
707     fi
708     # now create the target package
709     run_resume post-pkg_builddir_${target} || ${MLIBDIR}/pkgbuild_dir.sh \
710     "${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
711     ${BINDIR} || die "target: ${target} package-build failed"
712     resume_stamp post-pkg_builddir_${target}
713    
714     # build pkg-md5-sum if requested
715     run_resume post-md5sum_${target} || generate_package_md5sum \
716     --pcat "${PCAT}" \
717     --pname "${PNAME}" \
718     --pver "${PVER}" \
719     --pbuild "${PBUILD}" \
720     --parch "${ARCH}" \
721     --target "${target}"
722     resume_stamp post-md5sum_${target}
723    
724     echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
725     done
726    
727     # build several subpackages
728     elif [[ -n ${SPLIT_PACKAGES} ]]
729     then
730     split_save_variables
731     for subpackage in ${SPLIT_PACKAGES}
732     do
733     # get the right variables for the split
734     export PNAME="${subpackage}"
735     split_info_${PNAME}
736     # fix PCATEGORIE -> PCAT
737     if [[ ! -z ${PCATEGORIE} ]]
738     then
739     PCAT="${PCATEGORIE}"
740     unset PCATEGORIE
741     fi
742     if [[ ${PKGTYPE} = virtual ]]
743     then
744     # automatically set !pkgbuild here too
745     msetfeature "!pkgbuild"
746     fi
747    
748     # jump to next one if !pkgbuild is set in split_info
749     if mqueryfeature "!pkgbuild"
750     then
751     # restore smage environment
752     split_restore_variables
753     continue
754     fi
755    
756     # check if an special subpackage_pkgbuild exists
757     if typeset -f ${PNAME}_pkgbuild > /dev/null
758     then
759     # run it
760     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
761     resume_stamp post-${PNAME}_pkgbuild
762     fi
763     # now create the target package
764     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
765     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
766     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
767     resume_stamp post-pkg_builddir_${PNAME}
768    
769     # build pkg-md5-sum if requested
770     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
771     --pcat "${PCAT}" \
772     --pname "${PNAME}" \
773     --pver "${PVER}" \
774     --pbuild "${PBUILD}" \
775     --parch "${ARCH}"
776     resume_stamp post-md5sum_${PNAME}
777    
778     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
779    
780     # restore smage environment
781     split_restore_variables
782     done
783     # unset all saved smage variables
784     split_unset_variables
785    
786     else
787     run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
788     resume_stamp post-pkg_builddir
789    
790     # build pkg-md5-sum if requested
791     run_resume post-md5sum || generate_package_md5sum \
792     --pcat "${PCAT}" \
793     --pname "${PNAME}" \
794     --pver "${PVER}" \
795     --pbuild "${PBUILD}" \
796     --parch "${ARCH}"
797     resume_stamp post-md5sum
798    
799     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
800     fi
801    
802     # build src-pkg-tarball if requested
803     if mqueryfeature "srcpkgbuild"
804     then
805     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
806     resume_stamp post-srcpkgbuild
807     fi
808  fi  fi
809    
810  #the new buildpkg command  if mqueryfeature "buildlog"
811  case ${NOPKGBUILD} in  then
812   true|TRUE|yes|y)   bzip2 -9f /var/log/smage/${PKGNAME}.log
813   echo -e "NOPGKBUILD=true detected; Package will not be build ..."  else
814   ;;   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
815   *)  fi
  ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"  
  echo -e "\nPackage ${PKGNAME} successfully builded.\n"  
  ;;  
 esac  
816    
 #for sure  
 unset NOPKGBUILD  
   
817  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.24  
changed lines
  Added in v.2157